﻿
using HealthMonitor.Core.Dal;
using HealthMonitor.Core.Map;
using HealthMonitor.Util.Entities.HealthMonitor.Taos;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace HealthMonitor.Core.Context.Taos
{
    public class HealthMonitorTaosDataContext : DbContext, IWithDataSchema
    {

        public DbSet<StbHmBloodPress> StbHmBloodPress { get; set; } = default!;
        public string DataSchema { get; }
        public HealthMonitorTaosDataContext(DbContextOptions<HealthMonitorTaosDataContext> options)
            : base(options)
        {
            DataSchema = "health_monitor";
        }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            // base.OnConfiguring(optionsBuilder);
            optionsBuilder.UseTaos(@"Data Source=172.16.255.180;DataBase=health_monitor;Username=root;Password=taosdata;Port=6030;PoolSize=20;Protocol=Native");
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            //modelBuilder.HasDefaultSchema(DataSchema);

            //var typesToRegister = Assembly.GetExecutingAssembly().GetTypes()
            //    .Where(type => !string.IsNullOrEmpty(type.Namespace) && type.Namespace.StartsWith("HealthMonitor.Core.Map.HealthMonitor.Taos"))
            //    .Where(type => type.BaseType != null && type.BaseType.IsGenericType && type.BaseType.GetGenericTypeDefinition() == typeof(GenericEntityTypeConfiguration<>));

            //foreach (var t in typesToRegister)
            //{
            //    dynamic configurationInstance = Activator.CreateInstance(t)!;
            //    modelBuilder.ApplyConfiguration(configurationInstance);
            //}

            //base.OnModelCreating(modelBuilder);

            modelBuilder.Entity<StbHmBloodPress>().HasKey(e => e.Ts)
                  .HasName("PRIMARY");

            modelBuilder.Entity<StbHmBloodPress>().ToTable("stb_hm_bloodpress");

            modelBuilder.Entity<StbHmBloodPress>().Property(e => e.Ts)
                .HasColumnName("ts")
                .HasColumnType("timestamp");

            modelBuilder.Entity<StbHmBloodPress>()
                .Property(e => e.Serialno)
                .HasColumnName("serialno");

            modelBuilder.Entity<StbHmBloodPress>()
                .Property(e => e.BloodPressId)
                .HasColumnName("bloodpress_id");

            modelBuilder.Entity<StbHmBloodPress>()
               .Property(e => e.MessageId)
               .HasColumnName("message_id");

            modelBuilder.Entity<StbHmBloodPress>()
               .Property(e => e.SystolicValue)
               .HasColumnName("systolic_value");

            modelBuilder.Entity<StbHmBloodPress>()
               .Property(e => e.DiastolicValue)
               .HasColumnName("diastolic_value");


            modelBuilder.Entity<StbHmBloodPress>()
               .Property(e => e.LastUpdate)
               .HasColumnName("last_update");


            modelBuilder.Entity<StbHmBloodPress>()
               .Property(e => e.CreateTime)
               .HasColumnName("create_time");


            modelBuilder.Entity<StbHmBloodPress>()
               .Property(e => e.Method)
               .HasColumnName("method");


            modelBuilder.Entity<StbHmBloodPress>()
               .Property(e => e.IsDisplay)
               .HasColumnName("is_display");

            modelBuilder.Entity<StbHmBloodPress>()
              .Property(e => e.TailNo)
              .HasColumnName("serial_tail_no");
        }
    }
}
